
/**
 * Copyright 2012 Clint Combs
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.newhart.example

import org.newhart._

object DSLExample extends App {
  def rb1():String = auditCall { ""; f1() }
  def rf1():String = auditCall {
    auditData("x") { 1 + 2 }
    f1
  }
//  val r2:String = auditCall { f2("") }

  def f1() = ""
  def f2(s:String):String = s

  rb1
  rf1
  println(toString)
  f3
  fe

  def f3():Int = auditCall {
    2
  }

  def fe():Int = auditCall {
    f3
    null toString()
    1
  }

  /*
  def f4(s:String):String = auditCall {
    s
  }
  */
}
